package course.examples.Sensors.ShowValues;

import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

//exercise 1
public class SensorRawAccelerometerActivity extends Activity implements SensorEventListener { //implements SensorEventListener

    //exercise 2
    private SensorManager mSensorManager;
    private Sensor mAccelerometer;

    // exercise 3
    private TextView mXValueView, mYValueView, mZValueView;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        //exercise 3
        mXValueView = (TextView) findViewById(R.id.x_value_view);
        mYValueView = (TextView) findViewById(R.id.y_value_view);
        mZValueView = (TextView) findViewById(R.id.z_value_view);

        //exercise 2
        // Get reference to SensorManager
        mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);

        //exercise 2
        // Get reference to Accelerometer

        if (null == (mAccelerometer = mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER))) {
            Log.d("SensorStatus","Accelerometer available");
        } else {
            Log.d("SensorStatus","Accelerometer unavailable");
        }


    }

    // Register listener
    @Override
    protected void onResume() {
        super.onResume();

        //exercise 2
        mSensorManager.registerListener(this, mAccelerometer, SensorManager.SENSOR_DELAY_UI);

    }

    // Unregister listener
    @Override
    protected void onPause() {

        //exercise 2
        //mSensorManager.unregisterListener(this);
        super.onPause();
    }

    // Process new reading
    @Override // exercise 1
    public void onSensorChanged(SensorEvent event) {

        if (event.sensor.getType() == Sensor.TYPE_ACCELEROMETER) { // change sensor type

            //exercise 2
            float x = event.values[0];
            float y = event.values[1];
            float z = event.values[2];

            //exercise 3
            mXValueView.setText(String.valueOf(x));
            doSomething(y);
            mYValueView.setText(String.valueOf(y));
            mZValueView.setText(String.valueOf(z));

        }

    }

    //@Override //exercise 1
    public void onAccuracyChanged(Sensor sensor, int accuracy) {
        // Doing nothing
    }

    public boolean doSomething(float y) {
        // average of Y value readings
        //low pass filter, high pass filter,
        // store to sqlite, cloud

        // Doing nothing again
        return true;
    }
}